*     File kinit.f : Tue Jul 17 10:49:21 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(4) 1999/12/03
*
*     (c)copyright 1990-2000 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
      SUBROUTINE KINIT
      IMPLICIT REAL*8(A-H,O-Z)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 2001
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
 
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
 
      CHARACTER XSTR*14
 
      INCLUDE  'inclk.h'
*-----------------------------------------------------------------------
      real*8 mu,mu2
      common/grcqcdI/Ieps,Itree,Iself,Ivert,Ibox,Icol
      common/grcqcdR/mu,mu2,Cfac(10),Q2c,AlpS,fPDF(3)
      parameter (Cf=4.d0/3.d0,Cg=3.d0,Tr=0.5d0,Nf=5)
*-----------------------------------------------------------------------
      COMMON/KINEM1/S,W,FACT
      COMMON/KCNTL1/ICOST
      COMMON/CUT001/COSCUT(2,2),ENGYCT(2,2),Smin,E0min,pTcut(3),Ips
      COMMON/CUT002/CSCTps,ECTps
      common / knmflg / knmgvs, knmhst, knmsph, knmisr
*-----------------------------------------------------------------------
* 2-body kinematics
*
*  Integration variables
*        COS(the),Phi
*
*--- 1. Initialize constants for kinematics.


* S = (P1+P2)**2
* W = SQRT(S)
      if( knmgvs .eq. 1 ) then
          W = 14000.D0
      endif
      S = W*W
      totmas=amass1(3)+amass1(4)
      if(totmas.gt.w) then
	write(6,*)
     .' CM energy is less than the sum of final particle masses.'
	stop
      end if
*
* QCDPS preparation
*
      ips=0
c     if(Ips.eq.1) then
c      Ebeam=W/2.d0
c      call QPINIT(Ebeam)
c      CSCTps = cos(10*rad)
c      ECTps  = 1.d0
c     else
* set PDF parameters (CTEQ6L)
       Iset=3
       call SetCtq6(Iset)
c     end if
* Particle3-4 system mass
* S0=(p3+p4)**2
c     Smin=(W/2.d0)**2
      Smin=40**2
c     Smin=100**2
*******************************
* Angular cuts in Lab-frame.  *
*******************************
      csct=1.d0
c     csct=0.964d0
* minimum cos  cut for particle 3
      COSCUT(1,1)= -csct
* maximum cos  cut for particle 3
      COSCUT(2,1)=  csct
* minimum cos  cut for particle 4
      COSCUT(1,2)= -csct
* maximum cos  cut for particle 4
      COSCUT(2,2)=  csct

*******************************
* Energy  cuts in Lab-frame.  *
*******************************
* particle 3
* minimum energy cut
      ENGYCT(1,1) = AMASS1(3)
c     ENGYCT(1,1) = 8.d0
* maximum energy cut
      ENGYCT(2,1) = W
* particle 4
* minimum energy cut
      ENGYCT(1,2) = AMASS1(4)
c     ENGYCT(1,2) = 8.d0
* maximum energy cut
      ENGYCT(2,2) = W

      pTcut(1) = 0
      pTcut(2) = 0
      pTcut(3) = 1
c     pTcut(3) = 0




*If  ICOST=+-1
* -t=(p1-p3)**2 is used as integration variable. 
*  +1; forward peak.
*  -1; forward and backward peaks.
      ICOST=0

      WRITE(6,*)'*'
      WRITE(6,*)'* Kinematics initialization '
      WRITE(6,*)'* particle mass ',amass1
      WRITE(6,*)'* CM Energy ',W
      WRITE(6,*)'* COSCUT    '
      WRITE(6,'(2F20.8)')COSCUT
      WRITE(6,*)'* Integration Variable '
      if(icost.eq.0) then
      WRITE(6,*)'* cos3 '
      else if(icost.eq.+1) then
      WRITE(6,*)'* -t ;forward peak'
      else if(icost.eq.-1) then
      WRITE(6,*)'* -t ;forward-backward peak'
      else
      WRITE(6,*)'* icost should be 0 or +-1.',icost
      end if
      WRITE(6,*)'*'
 
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX
 
*----- BASES RELATED INITIALIZATIONS -----------------------------------
*--- 3. Dimension of integration variables.
 
          NDIM =   4
          NWILD=   4
 
C-----------------------------------------------------------------------
*--- 4. Region of integration.
 
      do 200 I=1,NDIM
        XL(I)  =   0.D0
        XU(I)  =   1.D0
        IG(I)  =   1
200   CONTINUE
C-----------------------------------------------------------------------
*--- 5. Number of iterations
      ITMX1  =  5
      ITMX2  =  5
 
c     NCALL  = 1000000
      NCALL  = 100000
 
*--- 6. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
       MXREG =   1
 
*--- 7. Set histograms
      if( knmhst .eq. 1 ) then
      NX = 50
      ND = 50
 
c     DO 100 I = 1, NDIM
c        WRITE(XSTR, 110) I
c 110    FORMAT('X(',I2,') SPECTRUM')
c        CALL XHINIT(I, XL(I), XU(I), NX, XSTR)
c 100 CONTINUE
 
         CALL XHINIT( 1, 0.d0, 100.d0, NX, 'Energy of Particle 3')
         CALL XHINIT( 2, 0.d0, 100.d0, NX, 'Energy of Particle 4')
         CALL XHINIT( 3,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT( 4,-1.d0,1.d0, NX, 'cos_the of Particle 4')

         CALL XHINIT( 5,sqrt(Smin),500.d0,   NX, 'sqrt(S)')
         CALL XHINIT( 6, 0.d0,500.d0, NX, 'E  jet')
         CALL XHINIT( 7, 0.d0,100.d0, NX, 'Et jet')
c        CALL XHINIT( 6, 0.d0,300.d0, NX, 'E  jet')
c        CALL XHINIT( 7, 0.d0, 50.d0, NX, 'Et jet')
      endif
      RETURN
      END
